<?php
namespace Teknisa\CTB\Controllers;

use Teknisa\CTB\Services\Ctb13000RecalculoSaldoFiscalService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;

class Ctb13000RecalculoSaldoFiscalController {

    protected $recalculoService;

    public function __construct(Ctb13000RecalculoSaldoFiscalService $recalculoService) {
        $this->recalculoService = $recalculoService;
    }

    /*
     * Função para recalcular o saldo fiscal de um determinado período.
     */
    public function recalculaSaldoFiscal(DTO\Request\Row $request, DTO\Response $response) {
        try {
            $row = $request->getRow();

            // Chama a função de recálculo.
            $this->recalculoService->recalculaSaldoFiscal($row);
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
}
