<?php
namespace Teknisa\CTB\Factories;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Ctb93000EscrituracaoContabilFiscalFactory {

    protected $entityManager;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function exportaECF(
        $cdempresa, $dtanoref, $idecfretifi, $idecftransmi, $nrrecibo, $nrseqarqmag
    ){
        $procedure = new StoredProcedure($this->entityManager->getConnection(), 'SPED_ECF_MESTRE');
        $procedure->addParam(new Param('P_CDEMPRESA'   , Param::PARAM_INPUT, $cdempresa   , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_ANO'         , Param::PARAM_INPUT, $dtanoref    , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_RETIFICADORA', Param::PARAM_INPUT, $nrrecibo    , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_ECDTRANS'    , Param::PARAM_INPUT, $idecftransmi, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRSEQARQMAG' , Param::PARAM_INPUT, $nrseqarqmag , Param::PARAM_TYPE_STR));
        $procedure->execute();
    }
    
    public function selectArqMag ($nrseqarqmag){
        $sql = "SELECT * FROM ARQMAGNETICO WHERE NRSEQARQMAG = :NRSEQARQMAG ORDER BY NRORDREGARQ";
        
        $params = array(
            'NRSEQARQMAG'=> $nrseqarqmag
        );
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);

        return $std->fetchAll();
    }
    
}