function Ctb72800_RecalculoSaldosComerciais_Controller(ScreenService, Ctb72800_RecalculoSaldosComerciais_Service){
    
    var messages = {
        DATA_INICIO_FORA_PERIODO_CONTABIL :  "Data início deve estar dentro do período contábil.",
        REQUEST_SUCCESS: 'Operação realizada com sucesso.',
        DATA_NAO_POSSUI_MES: 'Data Passada não possui mês.'
    };
    
    var paramMessages = {
        CAMPO_VAZIO : function(params){
            var message = 'O campo ? está vazio.';
            return message.replace('?', fieldNames[params[0]]);
        }
    };
    
     var fieldNames = {
            CDEMPRESA : 'Empresa',
            DTSALDO: 'Data início'
        };
    
    function message(messageCode, params){
        if(params === undefined){
            return messages[messageCode];
        }
        else{
            return  paramMessages[messageCode](params);
        }
    }
    
    function requestSuccess(){
        return function(response){
            var messageCode = 'REQUEST_SUCCESS';
            ScreenService.showMessage(message(messageCode), 'SUCCESS');
        };
    }
    
    function requestError(){
        return function(response){
            var errorMessage = 'Timeout';
			if (response.data){
				errorMessage = message(response.data.error, response.data.messageParams);
			}
            ScreenService.showMessage(errorMessage);
        };
    }
    
    function rowValidForValidatePeriodoContabil(row){
        return (row.CDEMPRESA && row.DTSALDO);
    }
    
    this.recalcularSaldo = function(widget){
        if(widget.isValid()){
            Ctb72800_RecalculoSaldosComerciais_Service.recalcularSaldo(widget.currentRow).then(
                requestSuccess(),
                requestError()
            );
        }
    };
    
    this.validatePeriodoContabil = function(currentRow){
        if(rowValidForValidatePeriodoContabil(currentRow)){
            Ctb72800_RecalculoSaldosComerciais_Service.validatePeriodoContabil(currentRow).then(
                function(success){},
                requestError()
            );
        }
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register("Ctb72800_RecalculoSaldosComerciais_Controller", Ctb72800_RecalculoSaldosComerciais_Controller);
});